using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using EvilAttributes;

namespace EvilAttributes.Tests
{
    [TestClass()]
    public class ValidateLessThanOrEqualToAttributeTests
    {
        [TestMethod()]
        public void ValidateLessThanOrEqualToAttribute_Property1IsLessThanProperty2Test()
        {
            TestEntity entity = new TestEntity();
            entity.Property1 = 10;
            entity.Property2 = 11;

            Assert.IsTrue(entity.IsValid(), "Entity failed validation.");
            Assert.IsTrue(entity.ValidationErrors.Count == 0, "ValidationErrors was not empty.");
        }

        [TestMethod()]
        public void ValidateLessThanOrEqualToAttribute_Property1IsGreaterThanProperty2Test()
        {
            TestEntity entity = new TestEntity();
            entity.Property1 = 11;
            entity.Property2 = 10;

            Assert.IsFalse(entity.IsValid(), "Entity passed validation.");
            Assert.IsTrue(entity.ValidationErrors.Count > 0, "ValidationErrors was empty.");
        }

        [TestMethod()]
        public void ValidateLessThanOrEqualToAttribute_Property1IsEqualToProperty2Test()
        {
            TestEntity entity = new TestEntity();
            entity.Property1 = 10;
            entity.Property2 = 10;

            Assert.IsTrue(entity.IsValid(), "Entity failed validation.");
            Assert.IsTrue(entity.ValidationErrors.Count == 0, "ValidationErrors was not empty.");
        }

        #region Private TestEntity Class

        private class TestEntity : EvilBaseEntity
        {
            private int _property1;
            private int _property2;

            [ValidateLessThanOrEqualTo("Property2", "Property1 must be less than or equal Property2.")]
            public int Property1
            {
                get { return _property1; }
                set { _property1 = value; }
            }

            public int Property2
            {
                get { return _property2; }
                set { _property2 = value; }
            }
        }

        #endregion
    }
}
