using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using EvilAttributes;

namespace EvilAttributes.Tests
{
    [TestClass()]
    public class ValidateMultipleOfAttributeTests
    {
        [TestMethod()]
        public void ValidateMultipleOfAttribute_Property1IsAMultipleOfProperty2Test()
        {
            TestEntity entity = new TestEntity();
            entity.Property1 = 50;
            entity.Property2 = 10;

            Assert.IsTrue(entity.IsValid(), "Entity failed validation.");
            Assert.IsTrue(entity.ValidationErrors.Count == 0, "ValidationErrors was not empty.");
        }

        [TestMethod()]
        public void ValidateMultipleOfAttribute_Property1IsNotAMultipleOfProperty2Test()
        {
            TestEntity entity = new TestEntity();
            entity.Property1 = 51;
            entity.Property2 = 10;

            Assert.IsFalse(entity.IsValid(), "Entity passed validation.");
            Assert.IsTrue(entity.ValidationErrors.Count > 0, "ValidationErrors was empty.");
        }

        #region Private TestEntity Class

        private class TestEntity : EvilBaseEntity
        {
            private long _property1;
            private long _property2;

            [ValidateMultipleOf("Property2", "Property1 must be a multiple of Property2.")]
            public long Property1
            {
                get { return _property1; }
                set { _property1 = value; }
            }

            public long Property2
            {
                get { return _property2; }
                set { _property2 = value; }
            }
        }

        #endregion
    }
}
