using System;
using System.Collections.Generic;
using System.Text;

namespace EvilAttributes
{
    /// <summary>
    /// Allows an entity to be validated.
    /// </summary>
    public interface IValidatable
    {
        /// <summary>
        /// Determines if the entity is valid.
        /// </summary>
        /// <returns>True if the entity is valid, false otherwise.</returns>
        /// <remarks>
        /// An entity is valid only if all attributes applied to the entity pass validation.
        /// </remarks>
        bool IsValid();

        /// <summary>
        /// Gets the collection of validation errors for the entity.
        /// </summary>
        IList<string> ValidationErrors { get; }
    }
}
