using System;
using System.Collections.Generic;
using System.Text;

namespace EvilAttributes
{
    /// <summary>
    /// Allows an attribute to perform entity validation.
    /// </summary>
    public interface IValidator
    {
        /// <summary>
        /// Gets the message for the attribute.
        /// </summary>
        string Message { get; }

        /// <summary>
        /// Validates a property value of an entity.
        /// </summary>
        /// <param name="value">The value of the property to validate.</param>
        /// <param name="entity">The entity that contains the property value.</param>
        /// <returns>True if the property value is valid, false otherwise.</returns>
        bool ValidateValue(object value, object entity);
    }
}
