using System;
using System.Collections.Generic;
using System.Reflection;

namespace EvilAttributes
{
    public class SmartFieldInfo : ISmartMemberInfo
    {
        private readonly FieldInfo _fieldInfo;

        public SmartFieldInfo(FieldInfo fieldInfo)
        {
            _fieldInfo = fieldInfo;
        }

        public string Name
        {
            get { return _fieldInfo.Name; }
        }

        public Type PropertyType
        {
            get { return _fieldInfo.FieldType; }
        }

        public object GetValue(object entity, object[] index)
        {
            return _fieldInfo.GetValue(entity);
        }

        public EvilBaseAttribute[] GetCustomAttributes(Type type, bool inherit)
        {
            return (EvilBaseAttribute[]) _fieldInfo.GetCustomAttributes(type, inherit);
        }
    }
}