using System;
using System.Collections.Generic;
using System.Reflection;

namespace EvilAttributes
{
    public class SmartPropertyInfo : ISmartMemberInfo
    {
        private readonly PropertyInfo _propertyInfo;

        public SmartPropertyInfo(PropertyInfo propertyInfo)
        {
            _propertyInfo = propertyInfo;
        }

        public string Name
        {
            get { return _propertyInfo.Name; }
        }

        public Type PropertyType
        {
            get { return _propertyInfo.PropertyType; }
        }

        public object GetValue(object entity, object[] index)
        {
            return _propertyInfo.GetValue(entity, index);
        }

        public EvilBaseAttribute[] GetCustomAttributes(Type type, bool inherit)
        {
            return (EvilBaseAttribute[]) _propertyInfo.GetCustomAttributes(type, inherit);
        }
    }
}